import org.apache.spark.ml.{Pipeline, PipelineModel}
import org.apache.spark.ml.linalg.Vector
import org.apache.spark.sql.Row
import com.datastax.spark.connector._
import org.apache.spark.SparkContext
import org.apache.spark.SparkContext._
import org.apache.spark.SparkConf
import org.apache.spark.sql.DataFrame
import org.apache.spark.ml.classification._
import scala.math.sqrt
import org.apache.spark.ml.linalg.Vectors
import org.apache.spark.ml.linalg.Vectors._
import org.apache.spark.ml.feature._
import org.apache.spark.ml.tuning.ParamGridBuilder
import org.apache.spark.ml.tuning.CrossValidator
import org.apache.spark.ml.evaluation._

import org.apache.spark.sql.SQLContext


val sqlContext = new SQLContext(sc);
import sqlContext.implicits._;

val dsDoc = sqlContext.read.textFile("data/document.txt").filter(_.value.length > 0)

val wordSplitter = new Tokenizer().setInputCol("value").setOutputCol("tokens")
wordSplitter.transform(dsDoc).show

val trivialWordRemover = new StopWordsRemover().setInputCol("tokens").setOutputCol("significantWords")

// show the significant words
trivialWordRemover.transform(wordSplitter.transform(dsDoc)).show

val tuplizer = new NGram().setInputCol("significantWords").setOutputCol("biGrams")

tuplizer.transform(trivialWordRemover.transform(wordSplitter.transform(dsDoc))).show(100)
