import org.apache.spark.streaming.twitter.TwitterUtils
import org.apache.spark.streaming.{Seconds, StreamingContext}
import org.apache.spark.{SparkConf, SparkContext}
import java.util.concurrent.atomic.AtomicLong

sc.setLogLevel("ERROR")
val consumerKey = YOUR_INFO
val consumerSecret = YOUR_INFO
val accessToken = YOUR_INFO
val accessTokenSecret = YOUR_INFO
System.setProperty("twitter4j.oauth.accessToken",accessToken)
System.setProperty("twitter4j.oauth.accessTokenSecret",accessTokenSecret)
System.setProperty("twitter4j.oauth.consumerKey",consumerKey)
System.setProperty("twitter4j.oauth.consumerSecret",consumerSecret)
val ssc = new StreamingContext(sc, Seconds(5))
val tweetStream = TwitterUtils.createStream(ssc, None)

object AppState  {
    val runningTweetCount = new AtomicLong(0)
    val runningPossibleNotableTweetCount = new AtomicLong(0)

    def isPlausiblyNotable(strTweetText: String) : Boolean = {  strTweetText.contains("the flu") || strTweetText.contains("influenza") || strTweetText.contains("bad cold") || strTweetText.contains("a flu") || strTweetText.contains("sneez") || strTweetText.contains("cough") || strTweetText.contains("body ache") || strTweetText.contains("fever") }

    def run() {
        tweetStream.foreachRDD((rdd, time) => { val countNewTweets:Long = rdd.count(); runningTweetCount.getAndAdd(countNewTweets);  val countNewNotableTweets = rdd.filter(status => { val strTweetText = status.getText(); val isPossibleNotable = strTweetText.contains("vaccin") || strTweetText.contains("immuniz"); if (isPossibleNotable) println(strTweetText); isPossibleNotable }).count;  runningPossibleNotableTweetCount.getAndAdd(countNewNotableTweets); println(s"$countNewTweets tweets at time $time; possible Notable tweets thus far are ${runningPossibleNotableTweetCount.get()} out of  ${runningTweetCount.get()}"); }); 
    
        ssc.start()
        ssc.awaitTermination()
    }
}

AppState.run()

