import org.apache.spark.streaming.twitter.TwitterUtils
import org.apache.spark.streaming.{Seconds, StreamingContext}
import org.apache.spark.{SparkConf, SparkContext}
import twitter4j.Status;

sc.setLogLevel("ERROR")
val consumerKey = "YOUR_INFO"
val consumerSecret = "YOUR_INFO"
val accessToken = "YOUR_INFO"
val accessTokenSecret = "YOUR_INFO"
System.setProperty("twitter4j.oauth.accessToken",accessToken)
System.setProperty("twitter4j.oauth.accessTokenSecret",accessTokenSecret)
System.setProperty("twitter4j.oauth.consumerKey",consumerKey)
System.setProperty("twitter4j.oauth.consumerSecret",consumerSecret)
val ssc = new StreamingContext(sc, Seconds(5))
val tweetStream = TwitterUtils.createStream(ssc, None)

tweetStream.foreachRDD((rdd, time) => { val countNewTweets:Long = rdd.count(); println(s"$countNewTweets tweets at time $time }") })
//val tweetTextsStream = tweetStream.filter(_.getGeoLocation() != null).map(status => (status.getText() + (if (status.getGeoLocation() == null) "" else s" from [${status.getGeoLocation.getLatitude}, ${status.getGeoLocation.getLongitude}]")))
//val tweetTextsStream = tweetStream.filter(status => { val strText = status.getText(); strText.contains("the flu") || strText.contains("influenza") || strText.contains("bad cold") || strText.contains("a flu") || strText.contains("sneez") || strText.contains("cough") || strText.contains("body ache") || strText.contains("fever") }).map(status => { runningTotalILICount += 1; (status.getText() + (if (status.getGeoLocation() == null) "" else s" from [${status.getGeoLocation.getLatitude}, ${status.getGeoLocation.getLongitude}]")) })

//val tweetTextsStream = tweetStream.filter(status => isPlausiblyILI(status.getText())).map(status =>  (status.getText() + (if (status.getGeoLocation() == null) "" else s" from [$
val tweetTextsStream = tweetStream.filter(status => (status.getPlace() != null)).map(status =>  s"${status.getText()}, Place: ${status.getPlace().getFullName()} " + (if (status.getGeoLocation() == null) "" else s" from [${status.getGeoLocation.getLatitude}, ${status.getGeoLocation.getLongitude}]")) 

val keyPhraseMap = Map(raw"the flu" -> 1, raw"influenza" -> 1, raw"\Wsick" -> 1, raw"\Will\W" -> 1, raw"^ill\W" -> 1, """^ill$""" -> 1, """^ill$""" -> 1, raw"illness" -> 1, raw"body\s*ache" -> 1, raw"fever" -> 1, raw"a cold" -> 1, raw"bad cold" -> 1, raw"a flu" -> 1, raw"sneez" -> 1, raw"cough" -> 1, raw"vaccin" -> 1, raw"immuniz" -> 1, raw"measles" -> 1, raw"pox" -> 1, raw"pertussis" -> 1, raw"whooping\s*cough" -> 1, raw"doctor" -> 1, raw"cigarette" -> 1, raw"e-cigarette" -> 1, raw"electronic cigarette" -> 1, raw"e-cig" -> 1, raw"smoking" -> 1, raw"smoke break" -> 1, raw"vaping" -> 1, raw"vaped" -> 1, raw"tobacco" -> 1)


// first, extract instances of key phrases in the tweet
// the next is deprecated because it looks only within words
//        val wordCountPairs = tweetStream.map(_.getText).flatMap(_.split(raw"[^a-zA-Z]+")).filter(tweetWord => keyPhraseMap.keys.exists(keyPhrase => tweetWord.contains(keyPhrase))).map(tweetWord => (tweetWord, 1))
//        val interestingTweetsAndKeyphrasesStream = tweetStream.map(status => { val strText = status.getText; (status, keyPhraseMap.keySet.filter(keyPhrase => strText.contains(keyPhrase) ) )}).filter((status: Status, collEnclosedKeyphrases:Set[String]) => (collEnclosedKeyphrases.size > 0))
val interestingTweetsAndKeyphrasesStream = tweetStream.map(status => { val strText = status.getText; Console.out.flush(); (status, keyPhraseMap.keySet.filter(keyPhraseRegexp => keyPhraseRegexp.r.findFirstIn(strText).isDefined ))}).filter((p:Tuple2[Status, Set[String] ]) => (p._2.size > 0))

// unfortunately, DStreams do not have an unzip method, so we undertake this directly with two different maps
val interestingTweetsStream = interestingTweetsAndKeyphrasesStream.map((p:Tuple2[Status, Set[String] ]) => p._1)

val interestingTweetTextsStream = interestingTweetsStream.map(status => status.getText + "------------------------")

interestingTweetTextsStream.repartition(1).saveAsTextFiles("output/output","interestingTweets")

interestingTweetTextsStream.print()

ssc.start()
ssc.awaitTermination()
