import org.apache.spark.streaming.twitter.TwitterUtils
import org.apache.spark.streaming.{Seconds, StreamingContext}
import org.apache.spark.{SparkConf, SparkContext}
import scala.collection.immutable.Set;
import twitter4j.Status;
import java.util.concurrent.atomic.AtomicInteger

sc.setLogLevel("ERROR")
val consumerKey = "YOUR_INFO"
val consumerSecret = "YOUR_INFO"
val accessToken = "YOUR_INFO"
val accessTokenSecret = "YOUR_INFO"
System.setProperty("twitter4j.oauth.accessToken",accessToken)
System.setProperty("twitter4j.oauth.accessTokenSecret",accessTokenSecret)
System.setProperty("twitter4j.oauth.consumerKey",consumerKey)
System.setProperty("twitter4j.oauth.consumerSecret",consumerSecret)
val countSecondsPerUpdate = 30
val ssc = new StreamingContext(sc, Seconds(countSecondsPerUpdate))
ssc.checkpoint("checkpoints/")

val tweetStream = TwitterUtils.createStream(ssc, None)

val countMinutesPerSavedReport = 2
// the second term below is updates per minute
val countIterationsPerSavedReport = countMinutesPerSavedReport*(60/countSecondsPerUpdate)
val countIterations = new AtomicInteger(0)

// the following need to be in the same function as the code, and the next two given as functions (rather than methods) for spark to accept this
val fnNewPlaceCountStateForKey = ((newValuesForKey:Seq[Int], runningTotal:Option[Int]) =>  Some(runningTotal.getOrElse(0) + newValuesForKey.sum) )
val fnNewKeyPhraseCountStateForKey = ((newValuesForKey:Seq[Int], runningTotal:Option[Int]) =>  Some(runningTotal.getOrElse(0) + newValuesForKey.sum) )

val keyPhraseMap = Map(raw"the flu" -> 1, raw"influenza" -> 1, raw"[^\w]sick" -> 1, raw"[^\w]ill[^\w]" -> 1, raw"illness" -> 1, raw"body\s*ache" -> 1, raw"fever" -> 1, raw"a cold" -> 1, raw"bad cold" -> 1, raw"a flu" -> 1, raw"sneez" -> 1, raw"cough" -> 1, raw"vaccin" -> 1, raw"immuniz" -> 1, raw"measles" -> 1, raw"pox" -> 1, raw"pertussis" -> 1, raw"whooping\s*cough" -> 1)


// first, extract instances of key phrases in the tweet
// the next is deprecated because it looks only within words
//        val wordCountPairs = tweetStream.map(_.getText).flatMap(_.split(raw"[^a-zA-Z]+")).filter(tweetWord => keyPhraseMap.keys.exists(keyPhrase => tweetWord.contains(keyPhrase))).map(tweetWord => (tweetWord, 1))
//        val interestingTweetsAndKeyphrasesStream = tweetStream.map(status => { val strText = status.getText; (status, keyPhraseMap.keySet.filter(keyPhrase => strText.contains(keyPhrase) ) )}).filter((status: Status, collEnclosedKeyphrases:Set[String]) => (collEnclosedKeyphrases.size > 0))
val interestingTweetsAndKeyphrasesStream = tweetStream.map(status => { val strText = status.getText; (status, keyPhraseMap.keySet.filter(keyPhraseRegexp => keyPhraseRegexp.r.findFirstIn(strText).isDefined ))}).filter((p:Tuple2[Status, Set[String] ]) => (p._2.size > 0))

// unfortunately, DStreams do not have an unzip method, so we undertake this directly with two different maps
val interestingTweetsStream = interestingTweetsAndKeyphrasesStream.map((p:Tuple2[Status, Set[String] ]) => p._1)
val flattenedKeyphrasesStream = interestingTweetsAndKeyphrasesStream.flatMap((p:Tuple2[Status, Set[String] ]) => p._2)

val wordCountPairs = flattenedKeyphrasesStream.map(keyPhrase => (keyPhrase , 1))

// now update the state to keep track of these phrases
val updatedKeyPhraseCountStateKVStream = wordCountPairs.updateStateByKey[Int](fnNewKeyPhraseCountStateForKey)
updatedKeyPhraseCountStateKVStream.print(50);

// ok, now extract t`he places specifically from the interesting tweets...
val placeCountKVStream = interestingTweetsStream.map(status => Option(status.getPlace)).filter(_.isDefined).map((p:Option[twitter4j.Place]) => (p.head.getFullName, 1))
// and update the place state
val updatedPlaceCountStateKVStream = placeCountKVStream.updateStateByKey[Int](fnNewPlaceCountStateForKey)
updatedPlaceCountStateKVStream.print(10)

//because they change every itereation, save the interesting tweets away each iteration
//interestingTweetsStream.map(status => status.getText).repartition(1).saveAsTextFiles("output/output","interestingTweets")
   
interestingTweetsStream.map(status => status.getText).repartition(1).foreachRDD(rdd => rdd.foreachPartition(textsInPartition => textsInPartition.foreach(strText => strText

) 

).map(status => status.getText).repartition(1).saveAsTextFiles("output/output","interestingTweets")
   
   
if (countIterations.getAndAdd(1) % countIterationsPerSavedReport == 0)
    {
    // for saving away data, we are given the option of specifying a prefix and suffix.  
    // The prefix should specify BOTH the directory and the beginning of the file name.  
    //     NB: it is important to specify a prefix for the file name, as otherwise it starts with "-", which can confuse command line utilities
    // The suffix can give further refinements of the name.
    
    // We also repartition here so that we have only a single text file output for each of these -- not a file per original partition (which could be many)
    updatedKeyPhraseCountStateKVStream.repartition(1).saveAsTextFiles("output/output","keyPhraseCount")
    updatedPlaceCountStateKVStream.repartition(1).saveAsTextFiles("output/output","placeCount")
    }


ssc.start()
ssc.awaitTermination()

