import twitter4j.TwitterFactory
import twitter4j.auth.AccessToken;
import twitter4j.Query;
import twitter4j.GeoLocation;
import twitter4j.Status;
import scala.collection.JavaConversions._
import scala.math._


val consumerKey = "YOUR_INFO"
val consumerSecret = "YOUR_INFO"
val accessToken = "YOUR_INFO"
val accessTokenSecret = "YOUR_INFO"



val twitter = new TwitterFactory().getInstance()
  // Authorising with your Twitter Application credentials
twitter.setOAuthConsumer(consumerKey,consumerSecret)
twitter.setOAuthAccessToken(new AccessToken(accessToken, accessTokenSecret))

def isPlausiblyILI(tweet: Status) : Boolean = { val strTweetText = tweet.getText;  strTweetText.contains("the flu") || strTweetText.contains("influenza") || strTweetText.contains("a cold") || strTweetText.contains("bad cold") || strTweetText.contains("a flu") || strTweetText.contains("sneez") || strTweetText.contains("cough") || strTweetText.contains("body ache") || strTweetText.contains("fever") }


val maxDesiredTweets = 100000  // place an upperbound on our tweets

// search the area around Boston
val maxAllowableTweetsInPageForAPI = 100
// the query is updated using the paging associated with the cursor mechanism
//var query = new Query().query("sick OR ill").geoCode(new GeoLocation(42.3601, -71.0), 100, "mi").since("2016-11-10").count(maxAllowableTweetsInPageForAPI)

// Use: val (countTweetsProcessed, countInterestingTweetsProcessed, interestingTweets) = identifyInterestingTweetsRecursive(10000, isPlausiblyILI _ ,new Query().geoCode(new GeoLocation(52.1332, -106.67), 1000,"km").count(100))

// val (countTweetsProcessedSince1120, countInterestingTweetsProcessedSince1120, interestingTweetsSince1120) = identifyInterestingTweetsRecursive(10000, isPlausiblyILI _ ,new Query().geoCode(new GeoLocation(52.1332, -106.67), 1000,"km").count(100).since("2016-11-20"))


//val (countTweetsProcessed2, countInterestingTweetsProcessed2, interestingTweets2, earliestDateProcessed) = identifyInterestingTweetsRecursive(10000, isPlausiblyILI _ ,new Query().geoCode(new GeoLocation(52.1332, -106.67), 1000,"km").resultType(Query.RECENT).count(maxAllowableTweetsInPageForAPI))
// the results go back much further if use a search query (rather than just no search query)
val (countTweetsProcessed7, countInterestingTweetsProcessed7, interestingTweets7, earliestDateProcessed7) = identifyInterestingTweetsRecursive(10000, isPlausiblyILI _ ,new Query().geoCode(new GeoLocation(52.1332, -106.67), 100,"km").query(""""flu" OR "sick" OR "ill"""").since("2016-11-20").resultType(Query.RECENT).count(maxAllowableTweetsInPageForAPI))
//val (countTweetsProcessed5, countInterestingTweetsProcessed5, interestingTweets5, earliestDateProcessed5) = identifyInterestingTweetsRecursive(10000, isPlausiblyILI _ ,new Query().geoCode(new GeoLocation(52.1332, -106.67), 100,"km").query("sick").since("2016-11-20").resultType(Query.RECENT).count(maxAllowableTweetsInPageForAPI))

// The following method takes
//      a maximum count of tweets to examine (process)
//      a predicate taking a Status associated with a tweet, and returning a boolean indicating if that tweet is of interest to return
//      a query to execute
// returns a tuple of
//      the total number of tweets processed (whether interesting or not)
//      the total number of interesting tweets found
//      a  Sequence of those that are interesting 
//      the earliest Date encountered within the above
def identifyInterestingTweetsRecursive(maxTweetsToProcess: Int, fnIsInteresting: (Status => Boolean), query: Query) : (Int, Int, Seq[Status], java.util.Date) = 
    {
    val results = twitter.search(query)
    // get the number of tweets to process in this Page, considering both the number available and the number we still need to process
    // note that the semantics of take are such that it returns a collection of tweets whose cardinality is the minimum of 
    // countTweetsRemainingUpperBound and the number of tweets in this Page
    val tweetsInPageToProcess = results.getTweets.take(maxTweetsToProcess)
    val countTweetsProcessedThisPage = tweetsInPageToProcess.size

    //    ok, now filter the tweets to be specifically the interesting one
    val interestingTweetsThisPage = tweetsInPageToProcess.filter((status:Status) => fnIsInteresting(status)).toVector
    val countInterestingTweetsThisPage = interestingTweetsThisPage.size

    println(s"$countTweetsProcessedThisPage tweets received on page ($countInterestingTweetsThisPage of possible interest)");
    // we need to continue only if we have BOTH additional tweets remaining and tweets that we still need to process
    if ((countTweetsProcessedThisPage < maxTweetsToProcess) && results.hasNext)
        {
        val (countTweetsProcessedInLaterPages, countInterestingTweetsProcessedInLaterPages, interestingTweetsInLaterPages, earliestDateProcessed) = identifyInterestingTweetsRecursive(maxTweetsToProcess - countTweetsProcessedThisPage, fnIsInteresting, results.nextQuery)
        
        // return a 3-tuple combining the results in this page with those from later pages
        ( countTweetsProcessedThisPage + countTweetsProcessedInLaterPages, 
          countInterestingTweetsThisPage + countInterestingTweetsProcessedInLaterPages,
          interestingTweetsThisPage ++ interestingTweetsInLaterPages,
          earliestDateProcessed)
        }
    else
        // otherwise, if this is the final page, just return the number from this page
        ( countTweetsProcessedThisPage, countInterestingTweetsThisPage, interestingTweetsThisPage, tweetsInPageToProcess.last.getCreatedAt )
    }

// returns the total number of tweets found, the total number of interesting tweets found, and a stream of those that are interesting 
def identifyInterestingTweetsImperative(maxDesiredTweets: Int, fnIsInteresting: (Status => Boolean), query: Query) : (Int, Int, Seq[Status], java.util.Date) = 
    {
    var countTweetsReceived = 0
    var countInterestingTweetsReceived = 0
    val filteredTweetsAcrossAllPages = Vector[Status]()
    var minimumDateProcessedThusFar : java.util.Date = null
    
    var hasPossibleAdditionalResultsToProcess = true
    do
        {   
        val results = twitter.search(query)
        // get the number of tweets to process in this Page, considering both the number available and the number we still need to process
        // note that the semantics of take are such that it returns a collection of tweets whose cardinality is the minimum of 
        // countTweetsRemainingUpperBound and the number of tweets in this Page
        
        val tweetsInPageToProcess = results.getTweets.take(maxDesiredTweets - countTweetsReceived)
        val countTweetsToProcessInPage = tweetsInPageToProcess.size
        minimumDateProcessedThusFar = tweetsInPageToProcess.last.getCreatedAt 

        countTweetsReceived += countTweetsToProcessInPage
        
        //    ok, now filter the tweets to be specifically the interesting one
        val filteredTweetsThisPage = tweetsInPageToProcess.filter((status:Status) => fnIsInteresting(status)).toVector
        countInterestingTweetsReceived += filteredTweetsThisPage.size
        filteredTweetsAcrossAllPages = filteredTweetsAcrossAllPages ++ filteredTweetsThisPage

        // we need to continue only if we have BOTH additional tweets remaining and tweets that we still need to process
        hasPossibleAdditionalResultsToProcess = results.hasNext && (countTweetsRemainingUpperBound > 0)
        query = results.nextQuery
        
        println(s"Running total: Total tweets received $countTweetsReceived, of which countInterestingTweetsReceived are of possible influenza-like illness");
        }
    while (hasPossibleAdditionalResultsToProcess)

    ( countTweetsReceived, filteredTweetsThisPage, filteredTweetsAcrossAllPages, minimumDateProcessedThusFar )
    }

