// **** began session here   ****
// perform imports and set up
import breeze.linalg._
import breeze.plot._
import breeze.numerics._
import org.apache.spark.sql.types.DataTypes
import org.apache.spark.sql.types.StructField
import org.apache.spark.sql.types.StructType
import org.apache.spark.sql.SQLContext
val sqlContext = new SQLContext(sc)
import sqlContext.implicits._

// ok, look at the inferred schema -- in this case, very poor
val dfCCHSFromCSVUntyped = sqlContext.read.option("header", true).csv("/home/ndo885/Usask/Classes/898_ScalableSoftwareEngineeringAndDataScience/Data/CCHS.csv")
dfCCHSFromCSVUntyped.printSchema

// ok, now define elements of the schema
val cCHSSelectedFields = Array(StructField("GEOEGPRV", DataTypes.LongType),
StructField("GEOEDPMF", DataTypes.LongType),
StructField("SAME_TYP", DataTypes.LongType),
StructField("ADME_PRX", DataTypes.LongType),
StructField("ADME_N10", DataTypes.LongType),
StructField("DHHEGAGE", DataTypes.LongType),
StructField("DHHE_SEX", DataTypes.LongType),
StructField("DHHEGMS", DataTypes.LongType),
StructField("GENE_01", DataTypes.LongType),
StructField("GENE_02", DataTypes.LongType),
StructField("GENE_02A", DataTypes.LongType),
StructField("GENE_02B", DataTypes.LongType),
StructField("GENE_10", DataTypes.LongType),
StructField("GENEDHDI", DataTypes.LongType),
StructField("GENEDMHI", DataTypes.LongType),
StructField("HWTE_4", DataTypes.LongType),
StructField("HWTEGHTM", DataTypes.DoubleType),
StructField("HWTEGWTK", DataTypes.DoubleType),
StructField("HWTEGBMI", DataTypes.DoubleType),
StructField("CCCE_011", DataTypes.LongType),
StructField("CCCE_021", DataTypes.LongType),
StructField("CCCE_031", DataTypes.LongType),
StructField("CCCE_041", DataTypes.LongType),
StructField("CCCE_051", DataTypes.LongType),
StructField("CCCE_061", DataTypes.LongType),
StructField("CCCE_071", DataTypes.LongType),
StructField("CCCE_074", DataTypes.LongType),
StructField("CCCE_081", DataTypes.LongType),
StructField("CCCE_91A", DataTypes.LongType),
StructField("CCCE_101", DataTypes.LongType),
StructField("CCCE_111", DataTypes.LongType),
StructField("CCCE_121", DataTypes.LongType),
StructField("CCCE_131", DataTypes.LongType),
StructField("CCCE_141", DataTypes.LongType),
StructField("CCCE_151", DataTypes.LongType),
StructField("CCCE_161", DataTypes.LongType),
StructField("CCCE_171", DataTypes.LongType),
StructField("CCCE_211", DataTypes.LongType),
StructField("CCCE_251", DataTypes.LongType),
StructField("CCCE_261", DataTypes.LongType),
StructField("CCCE_280", DataTypes.LongType),
StructField("CCCE_290", DataTypes.LongType),
StructField("CCCE_331", DataTypes.LongType),
StructField("CCCEF1", DataTypes.LongType),
StructField("CCCEG901", DataTypes.LongType),
StructField("HCUE_1AA", DataTypes.LongType),
StructField("HCUE_01", DataTypes.LongType),
StructField("HCUEG02A", DataTypes.LongType),
StructField("HCUEG02B", DataTypes.LongType),
StructField("HCUEG02C", DataTypes.LongType),
StructField("HCUEG02D", DataTypes.LongType),
StructField("HCUEG02E", DataTypes.LongType),
StructField("HCUEG02F", DataTypes.LongType),
StructField("HCUEG02G", DataTypes.LongType),
StructField("HCUEG02H", DataTypes.LongType),
StructField("HCUEG02I", DataTypes.LongType),
StructField("HCUEG02J", DataTypes.LongType),
StructField("HCUE_04A", DataTypes.LongType),
StructField("HCUE_04", DataTypes.LongType),
StructField("HCUE_06", DataTypes.LongType),
StructField("HCUEGMDC", DataTypes.LongType),
StructField("HCUEFCOP", DataTypes.LongType),
StructField("RACE_6A", DataTypes.LongType),
StructField("RACE_6B1", DataTypes.LongType),
StructField("RACE_6C", DataTypes.LongType),
StructField("RACE_6D", DataTypes.LongType),
StructField("RACE_6E", DataTypes.LongType),
StructField("RACE_6F", DataTypes.LongType),
StructField("RACE_6G", DataTypes.LongType),
StructField("RACE_7A", DataTypes.LongType),
StructField("RACE_7B", DataTypes.LongType),
StructField("RACE_7C", DataTypes.LongType),
StructField("RACEF6R", DataTypes.LongType),
StructField("RACEF7", DataTypes.LongType),
StructField("TWDE_1", DataTypes.LongType),
StructField("TWDEDDDY", DataTypes.LongType),
StructField("TWDEDDDM", DataTypes.LongType),
StructField("TWDEDDDP", DataTypes.LongType),
StructField("FLUE_160", DataTypes.LongType),
StructField("PACE_1A", DataTypes.LongType),
StructField("PACE_1B", DataTypes.LongType),
StructField("PACE_1C", DataTypes.LongType),
StructField("PACE_1D", DataTypes.LongType),
StructField("PACE_1E", DataTypes.LongType),
StructField("PACE_1F", DataTypes.LongType),
StructField("PACE_1G", DataTypes.LongType),
StructField("PACE_1H", DataTypes.LongType),
StructField("PACE_1I", DataTypes.LongType),
StructField("PACE_1J", DataTypes.LongType),
StructField("PACE_1K", DataTypes.LongType),
StructField("PACE_1L", DataTypes.LongType),
StructField("PACE_1M", DataTypes.LongType),
StructField("PACE_1N", DataTypes.LongType),
StructField("PACE_1O", DataTypes.LongType),
StructField("PACE_1P", DataTypes.LongType),
StructField("PACE_1Q", DataTypes.LongType),
StructField("PACE_1R", DataTypes.LongType),
StructField("PACE_1S", DataTypes.LongType),
StructField("PACE_1T", DataTypes.LongType),
StructField("PACE_1Z", DataTypes.LongType),
StructField("PACE_1U", DataTypes.LongType),
StructField("PACE_1V", DataTypes.LongType),
StructField("PACE_4A", DataTypes.LongType),
StructField("PACE_4B", DataTypes.LongType),
StructField("PACE_6", DataTypes.LongType),
StructField("PACEDEE", DataTypes.DoubleType),
StructField("PACEFLEI", DataTypes.LongType),
StructField("PACEDFM", DataTypes.LongType),
StructField("PACEDFR", DataTypes.LongType),
StructField("PACEFD", DataTypes.LongType),
StructField("PACEDPAI", DataTypes.LongType),
StructField("SMKE_01A", DataTypes.LongType),
StructField("SMKE_202", DataTypes.LongType),
StructField("SMKEDSTY", DataTypes.LongType),
StructField("ETSE_5", DataTypes.LongType),
StructField("ALCE_1", DataTypes.LongType),
StructField("ALCEDTYP", DataTypes.LongType),
StructField("REPE_1", DataTypes.LongType),
StructField("INJE_01", DataTypes.LongType),
StructField("INJE_16", DataTypes.LongType),
StructField("INJEDSTT", DataTypes.LongType),
StructField("SDCEGCBG", DataTypes.LongType),
StructField("SDCEFIMM", DataTypes.LongType),
StructField("SDCEGCGT", DataTypes.LongType),
StructField("SDCEGLNG", DataTypes.LongType),
StructField("EDUEDH04", DataTypes.LongType),
StructField("EDUEDR04", DataTypes.LongType),
StructField("DHHEGHSZ", DataTypes.LongType),
StructField("DHHEGL12", DataTypes.LongType),
StructField("DHHEGLE5", DataTypes.LongType),
StructField("DHHEG611", DataTypes.LongType),
StructField("DHHEGLVG", DataTypes.LongType),
StructField("DHHEGBE", DataTypes.LongType),
StructField("DINCEG2", DataTypes.LongType),
StructField("INCEGHH", DataTypes.LongType))

// ok, now read from the CSV file using the schema defined above
val dfCCHSFromCSV = sqlContext.read.schema(StructType(cCHSSelectedFields)).option("header", true).csv("/home/ndo885/Usask/Classes/898_ScalableSoftwareEngineeringAndDataScience/Data/CCHS.csv")

// infer the schema
val dfTestInfer = sqlContext.read.schema(StructType(cCHSSelectedFields)).option("header", true).option("inferSchema", true).csv("/home/ndo885/Usask/Classes/898_ScalableSoftwareEngineeringAndDataScience/Data/CCHS.csv")

// ok, now dfCCHSFromCSV is associated with a correct schema, but we still don't have 
// static typing
// Below, we will impose static typing, which will aid performance and checks to correctness

// ok, now select a subset of the data, so that we don't have to impose static typing for the entire schema
val dfCCHSBMIAgeSexSubset = dfCCHSFromCSV.select($"DHHEGAGE", $"DHHE_SEX", $"HWTEGBMI")

dfCCHSBMIAgeSexSubset.printSchema

// ok, now create a corresponding case class
case class CCHSBMIAgeSexSubsetSchema(DHHEGAGE:Long, DHHE_SEX: Long, HWTEGBMI:Double)

// now impose the correspondingly strongly typed dataset
val dsCCHSSelected = dfCCHSBMIAgeSexSubset.as[CCHSBMIAgeSexSubsetSchema]
dsCCHSSelected.filter(_.DHHEGAGE > 5).count
// show distinct values
dsCCHSSelected.filter(_.DHHEGAGE > 5).distinct.show
// two ways of referring to a column
// both of the below are untyped before the show
dsCCHSSelected.select($"DHHEGAGE").distinct.show
dsCCHSSelected.select(dsCCHSSelected("DHHEGAGE")).distinct.show


// another way of doing the query, using the name of the column
// the below is untyped before the show
dsCCHSSelected.select("DHHEGAGE").distinct.show
// now perform the above, ordering the results
// the below is untyped before the show
dsCCHSSelected.select("DHHEGAGE").distinct.orderBy("DHHEGAGE")
dsCCHSSelected.select("DHHEGAGE").distinct.orderBy("DHHEGAGE").show

// creation of Array of typed results
dsCCHSSelected.filter(_.DHHEGAGE > 5).show
dsCCHSSelected.filter(_.DHHEGAGE > 5).collect()

// creation of Array of untyped rows -- static typing can't be
// done because of the string used 
dsCCHSSelected.select("DHHEGAGE")
// the below is untyped before the show
dsCCHSSelected.select("DHHEGAGE").collect()
dsCCHSSelected.select($"DHHEGAGE").collect()

// the result of the "where" clause below is STATICALLY TYPED
dsCCHSSelected.where($"DHHEGAGE" > 5)
// the result of the select is untyped
dsCCHSSelected.where($"DHHEGAGE" > 5).select("DHHEGAGE")
dsCCHSSelected.where($"DHHEGAGE" > 5).select("DHHEGAGE").collect()

// the below is collected in terms of the case class
dsCCHSSelected.where($"DHHEGAGE" > 5).collect()
//the below are statically typed
dsCCHSSelected.where($"DHHEGAGE" > 5).map(_.DHHEGAGE)
dsCCHSSelected.where($"DHHEGAGE" > 5).map(_.DHHEGAGE).collect()
dsCCHSSelected.where($"DHHEGAGE" > 5)
dsCCHSSelected.where($"DHHEGAGE" > 5).collect()
dsCCHSSelected.where($"DHHEGAGE" > 5).collect().map(e => (e.DHHEGAGE.toDouble, e.HWTEGBMI))
dsCCHSSelected.where($"DHHEGAGE" > 5).collect().map(e => (e.DHHEGAGE.toDouble, e.HWTEGBMI)).unzip

// showing how zip and unzip work
val arrayOfTuples = Array(1,2,3).zip(Array(4,5,6))
arrayOfTuples.unzip

// now we apply unzip to go from an array of pairs to a pair of arrays
val (arrayRowAgeCats, arrayRowBMIs) = dsCCHSSelected.where($"DHHEGAGE" > 5).collect().map(e => (e.DHHEGAGE.toDouble, e.HWTEGBMI)).unzip
arrayRowBMIs
// showing how this works to produce an array of (fully typed) rows
dsCCHSSelected.where($"DHHEGAGE" > 5).collect().map(e => (e.DHHEGAGE.toDouble, e.HWTEGBMI))
// turn the arrays into (fully typed) DenseVectors
val (dvRowAgeCats, dvRowBMIs) = (DenseVector(arrayRowAgeCats), DenseVector(arrayRowBMIs))
// DenseVectors benefit from element-by-element operations (e.g., doubling each element of the ector)
dvRowBMIs
dvRowBMIs - dvRowAgeCats
dvRowBMIs * 2.0
dvRowBMIs

// ok, now create a scatterplot of the vectors above
val figAgeCatVsBMIs = Figure("ageCats vs. BMIs")
figAgeCatVsBMIs.subplot(0) += plot(dvRowAgeCats, dvRowBMIs, '.')
figAgeCatVsBMIs.refresh()

// ok, now we see to compute two data frames showing averages and standard deviations of BMIs for each age group, respectively
// the below is untyped
val dfAveragedBMIForAgeCat = dsCCHSSelected.groupBy($"DHHEGAGE").agg(avg($"HWTEGBMI"))
val dfStdDevBMIForAgeCat = dsCCHSSelected.groupBy($"DHHEGAGE").agg(stddev($"HWTEGBMI"))
dfAveragedBMIForAgeCat.show
dfStdDevBMIForAgeCat.show

//now create a corresponding filter
val figMeanBMIForAgeCat = Figure("Age category vs. Mean BMI")

// ok, now extract the values
// reminder of the fact that we map to an array of pairs
dfAveragedBMIForAgeCat.collect().map(e => (e.getLong(0).toDouble, e.getDouble(1)))
// now turn it into a pair of arrays
val (arrayAgeCat, arrayMeanBMIs) = dfAveragedBMIForAgeCat.collect().map(e => (e.getLong(0).toDouble, e.getDouble(1))).unzip
// ok, now plot these
figMeanBMIForAgeCat.subplot(0) += plot(DenseVector(arrayAgeCat), DenseVector(arrayMeanBMIs), '.')
// now set the age labels
figMeanBMIForAgeCat.subplot(0).xlabel = "Age category"
figMeanBMIForAgeCat.subplot(0).ylabel = "Mean BMI"
