// be sure to run the below from the folder for the spark installation
// start the normal spark context -- will will create a new one below
sc.stop()
// perform necessary imports
import com.datastax.spark.connector._, 
org.apache.spark.SparkContext, 
org.apache.spark.SparkContext._, 
org.apache.spark.SparkConf
// create a new conf
val conf = new SparkConf(true).set("spark.cassandra.connection.host", "blinchiki.usask.ca").set("spark.cassandra.auth.username", "nate").set("spark.cassandra.auth.password", "PASSWORD_GOES_HERE")
// now create the new spark context
val sc = new SparkContext("local", "test", conf)

// ok, now test out an RDD  to get statistics
val rddGPS = sc.cassandraTable("ethica_study_73", "gps")
rddGPS.first.getDouble("accu")
rddGPS.map(_.getDouble("accu")).stats()

// ok, now go on to perform operations using Spark SQL and DataFrames
import org.apache.spark.sql.SQLContext
// get the SQLContext -- be sure to do this with the NEW spark context
val sqlContext = new SQLContext(sc); 
import sqlContext.implicits._
// ok, extract some data from the GPS table
val dfGPS = sqlContext.read.format("org.apache.spark.sql.cassandra").options(Map("keyspace" -> "ethica_study_73", "table" -> "gps")).load().filter($"speed" < 5).filter($"accu" < 100)
dfGPS.count
dfGPS.cache()
dfGPS.printSchema
